function [khx,khy,khx_azim,khy_azim] = comp_domain(gamma,n_gamma,beta_min_gamma,beta_max_gamma,delta_beta,kmx,kmy,kz)

i=1;
khy=0;
khx=0;
khy_azim=0;
khx_azim=0;

for i_gamma=1:n_gamma % loop over aperture angle
	gamma_rad = (gamma(i_gamma) / 180) * pi ;
	tan_gamma = tan(gamma_rad) ;

	for beta=beta_min_gamma(i_gamma):delta_beta:beta_max_gamma(i_gamma)% loop over reflection azimuth
		%beta = 0;
		beta = (beta / 180) * pi ;

  		% rotation of the system of coordinates
  		kmx_azim = kmx * cos(beta) + kmy * sin(beta) ;
		kmy_azim =-kmx * sin(beta) + kmy * cos(beta) ;
%  		kmx_azim = kmx * cos(beta) - kmy * sin(beta) ;
%		kmy_azim = kmx * sin(beta) + kmy * cos(beta) ;

		% offset to angle transformation (1)
		const_1 = kz*sqrt(1+kmy_azim^2/kz^2) ;
		% coplanarity condition (1)
		const_2 = kmy_azim * kmx_azim / const_1 ;

		% offset to angle transformation (2)
		khx_azim(i) = const_1 * (-tan_gamma) ;
		% coplanarity condition (2)
%		khy_azim(i) = const_2 * tan_gamma ;
%	khy_azim(i)= khx_azim(i)*kmy_azim * kmx_azim / sqrt(kz^2 +kmy_azim^2);
	khy_azim(i)= - khx_azim(i)*kmy_azim * kmx_azim / (kz^2 +kmy_azim^2);
%		khy_azim(i) = -const_2 * tan_gamma ;

%                tan_alpha=kmx_azim/kz;
%                sin_delta=kmy_azim/sqrt(kmy_azim^2 + kz^2) ;
%		khy_azim =kz * tan_gamma * tan_alpha * sin_delta ;


		% go back original system of coordinates
		khx(i) = khx_azim(i) * cos(beta) - khy_azim(i) * sin(beta) ;
		khy(i) = khx_azim(i) * sin(beta) + khy_azim(i) * cos(beta) ;

%		khx(i) = khx_azim(i) * cos(beta) + khy_azim(i) * sin(beta) ;
%		khy(i) = -khx_azim(i) * sin(beta) + khy_azim(i) * cos(beta) ;

%		khx(i) = khx_azim(i)  ;
%		khy(i) = khy_azim(i)  ;


		i=i+1;
	end
end

