function [dkhx,dkhy,gamma_vec,beta_vec] = comp_grad(gamma,n_gamma,beta_min_gamma,beta_max_gamma,delta_beta,kmx,kmy,khx,khy,khx_azim,khy_azim,kz)

i=1;
dkhy_dazim=0;
dkhx_dazim=0;

dkhy=0;
dkhx=0;

if (kz ==0) 
kz_den=1;
else
kz_den=kz;
end


for i_gamma=1:n_gamma % loop over aperture angle
	gamma_rad = (gamma(i_gamma) / 180) * pi ;
	tan_gamma = tan(gamma_rad) ;

	for beta=beta_min_gamma(i_gamma):delta_beta:beta_max_gamma(i_gamma)% loop over reflection azimuth
		%beta = 0;
	beta_vec(i)=beta;
	gamma_vec(i)=gamma(i_gamma);
		beta = (beta / 180) * pi ;

  		% rotation of the system of coordinates
  		kmx_azim = kmx * cos(beta) + kmy * sin(beta) ;
		kmy_azim =-kmx * sin(beta) + kmy * cos(beta) ;

                dkmx_dazim= - kmx*sin(beta) + kmy*cos(beta);
                dkmy_dazim= - kmx*cos(beta) - kmy*sin(beta);

                tan_alpha=kmx_azim/kz_den;

                sin_delta=kmy_azim/sqrt(kmy_azim^2 + kz_den^2) ;
                cos_delta=abs(kz_den)/sqrt(kmy_azim^2 + kz_den^2) ;

                dkhx_dazim(i)=-tan_gamma*sin_delta*dkmy_dazim ;

%                dkhx_dazim(i)=tan_gamma*dkmy_dazim ;
%                dkhx_dazim(i)=dkmy_dazim ;

%                dkhy_dazim(i)=tan_gamma*(-sin_delta*dkmx_dazim + ...
%                                      tan_alpha*(cos_delta^3)*dkmy_dazim) ;

                dkhy_dazim(i)=tan_gamma*(sin_delta*dkmx_dazim + ...
                                      tan_alpha*(cos_delta^3)*dkmy_dazim) ;

%                dkhy_dazim(i)=tan_gamma*(sin_delta*dkmx_dazim );
%%                                      tan_alpha*(cos_delta^3)*dkmy_dazim) ;
%% as in fortran
%                dkhy_dazim(i)=tan_gamma*(sin_delta*dkmx_dazim - ...
%                                      tan_alpha*(cos_delta^3)*dkmy_dazim) ;

	dkhx(i) = dkhx_dazim(i)*cos(beta) - dkhy_dazim(i)*sin(beta) + ...
                          (- khx_azim(i)*sin(beta) - khy_azim(i)*cos(beta));
	dkhy(i) = dkhx_dazim(i)*sin(beta) + dkhy_dazim(i)*cos(beta) + ...
                          (  khx_azim(i)*cos(beta) - khy_azim(i)*sin(beta));

%	dkhy(i) = dkhx_dazim(i)*sin(beta) + ...
%                          (  - khy(i)*sin(beta));

%		dkhx(i) = dkhx_dazim(i);
%		dkhy(i) = dkhy_dazim(i);
%

		i=i+1;
	end
end
