function [beta_min_gamma,beta_max_gamma] = bound_beta(type,beta_min,beta_max,beta_min_0,beta_max_0,gamma,gamma_min_min,gamma_max_max,power)

%if(gamma >=0)
%          beta_min_gamma=beta_min+(beta_min_0-beta_min)*((90-gamma)/(90))
%          beta_max_gamma=beta_max+(beta_max_0-beta_max)*((90-gamma)/(90))
%else
%          beta_min_gamma=beta_min+(beta_min_0-beta_min)*((90+gamma)/(90))
%          beta_max_gamma=beta_max+(beta_max_0-beta_max)*((90+gamma)/(90))
%
%end


switch type
  case {'const'}
    beta_min_gamma=beta_min;
    beta_max_gamma=beta_max;
  case {'lin'}
    if(gamma >=0)
      beta_min_gamma=beta_min+ ...
  (beta_min_0-beta_min)*((gamma_max_max-gamma)/(gamma_max_max-gamma_min_min));
      beta_max_gamma=beta_max+ ...
  (beta_max_0-beta_max)*((gamma_max_max-gamma)/(gamma_max_max-gamma_min_min));
    else
       beta_min_gamma=beta_min+ ...
  (beta_min_0-beta_min)*((gamma_max_max+gamma)/(gamma_max_max-gamma_min_min));
         beta_max_gamma=beta_max+ ...
  (beta_max_0-beta_max)*((gamma_max_max+gamma)/(gamma_max_max-gamma_min_min));
    end

  case {'sin'}
    conv=pi/2.;
    if(gamma >=0)
      beta_min_gamma=beta_min+ ...
  (beta_min_0-beta_min)*(sin(conv*(gamma_max_max-gamma)/(gamma_max_max-gamma_min_min))^power);
      beta_max_gamma=beta_max+ ...
  (beta_max_0-beta_max)*(sin(conv*(gamma_max_max-gamma)/(gamma_max_max-gamma_min_min))^power);
    else
       beta_min_gamma=beta_min+ ...
  (beta_min_0-beta_min)*(sin(conv*(gamma_max_max+gamma)/(gamma_max_max-gamma_min_min))^power);
       beta_max_gamma=beta_max+ ...
  (beta_max_0-beta_max)*(sin(conv*(gamma_max_max+gamma)/(gamma_max_max-gamma_min_min))^power);
    end


  otherwise
    disp ('Unknown bound_beta type')
end

  
